
/* 
 * Przykładowy kod do książki: Algorytmy i struktury danych w języku PHP 7
 * 
 * Autor: Mizanur Rahman <mizanur.rahman@gmail.com>
 * 
 */
 
SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";

--
-- Baza danych: 'helion'
--

-- --------------------------------------------------------

--
-- Struktura tabeli 'categories'
--

CREATE TABLE 'categories' (
  'id' int(11) NOT NULL,
  'categoryName' varchar(100) NOT NULL,
  'parentCategory' int(11) DEFAULT '0',
  'sortInd' int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dane dla tabeli 'categories'
--

INSERT INTO 'categories' ('id', 'categoryName', 'parentCategory', 'sortInd') VALUES
(1, 'Pierwszy', 0, 0),
(2, 'Drugi', 1, 0),
(3, 'Trzeci', 1, 0),
(4, 'Czwarty', 3, 0),
(5, 'Piąty', 4, 0),
(6, 'Szósty', 5, 0),
(7, 'Siódmy', 6, 0),
(8, 'Ósmy', 7, 0),
(9, 'Dziewiąty', 1, 0),
(10, 'Dziesiąty', 2, 0);

-- --------------------------------------------------------

--
-- Struktura tabeli 'comments'
--

CREATE TABLE 'comments' (
  'id' int(11) NOT NULL,
  'comment' varchar(500) NOT NULL,
  'username' varchar(50) NOT NULL,
  'datetime' datetime NOT NULL,
  'parentID' int(11) NOT NULL,
  'postID' int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dane dla tabeli 'comments'
--

INSERT INTO 'comments' ('id', 'comment', 'username', 'datetime', 'parentID', 'postID') VALUES
(1, 'Pierwszy komentarz', 'Mirek', '2017-08-01 15:10:20', 0, 1),
(2, 'Pierwsza odpowiedź', 'Adrian', '2017-08-02 04:09:10', 1, 1),
(3, 'Odpowiedź na pierwszą odpowiedź', 'Michał', '2017-08-03 11:10:47', 2, 1),
(4, 'Odpowiedź na odpowiedź na pierwszą odpowiedź', 'Arnold', '2017-08-04 21:22:45', 3, 1),
(5, 'Odpowiedź na odpowiedź na odpowiedź na pierwszą odpowiedź', 'Adam', '2017-08-05 12:01:29', 4, 1),
(6, 'Drugi komentarz', 'Krzysiek', '2017-08-01 15:10:20', 0, 1),
(7, 'Pierwszy komentarz do drugiego wpisu', 'Marcin', '2017-08-02 04:09:10', 0, 2),
(8, 'Trzeci komentarz', 'Ignacy', '2017-08-03 11:10:47', 0, 1),
(9, 'Drugi komentarz do drugiego wpisu', 'Antoni', '2017-08-04 21:22:45', 0, 2),
(10, 'Odpowiedź na drugi komentarz do drugiego wpisu', 'Anatol', '2017-08-18 05:18:24', 9, 2);

--
-- Indeksy wypełnionych tabel
--

--
-- Indeksy tabeli 'categories'
--
ALTER TABLE 'categories'
  ADD PRIMARY KEY ('id');

--
-- Indeksy tabeli 'comments'
--
ALTER TABLE 'comments'
  ADD PRIMARY KEY ('id');

--
-- AUTO_INCREMENT wypełnionych tabel
--

--
-- AUTO_INCREMENT tabeli 'categories'
--
ALTER TABLE 'categories'
  MODIFY 'id' int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=11;
--
-- AUTO_INCREMENT tabeli 'comments'
--
ALTER TABLE 'comments'
  MODIFY 'id' int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=11;
